#include <iolpc2103.h>
#include "interrupts.h"
#include "led.h"
#include "bits.h"
#include "rtc.h"
#include "system.h"
#include <inarm.h>


// symple delay
void Delay (unsigned long a) { while (--a!=0); }

/**** INTERRUPTS HANDLERS ****/
// IRQ interrupt handler.
#pragma vector=0x18
__irq __arm void IRQ_ISR_Handler (void)
{
  void (*interrupt_function)();
  unsigned int vector;

  // Called at 1000 Hz rate.
  vector = VICVectAddr; // Get interrupt vector.
  interrupt_function = (void(*)())vector;
  (*interrupt_function)(); // Call vectored interrupt function.

  VICVectAddr = 0; // Clear interrupt in VIC.
}


void RTCInterrupt()
{
  (*RTC_function)();
}



void rtc_int()
{
  Led1Blink();
  ILR=0x3;      // clear all interrupt of RTC
}



int main()
{

  // InitFreq
  FreqInit();


  // Init RTC
  InitRTC();

  // Init led
  LedInit();

  /**** INTERRUPTS ****/
  //This will move the exception vectors in place.
  #ifdef RAM
    MEMMAP = 2;
  #else
    MEMMAP = 1;
  #endif
  __disable_interrupt();              //Disable interrupts.
  InitRTCInterrupt(rtc_int);          //Setup interrupt controller.
  __enable_interrupt();               //Enable interrupts.


  while(1) {


  }

}

